#!/bin/bash

OUTFILE="dynamic-pull-tests.yml"


# Prepare the environment
export TAG=""
if [[ -z "$CI_BUILD_TAG" ]]; then export TAG="$CI_COMMIT_REF_NAME"; else export TAG="$CI_BUILD_TAG" ; fi
if [ -z "$TAG" ]; then echo "failed to set tag" ; exit 1 ; fi

# Setup the file header
cat <<EOF >$OUTFILE
stages:
  - run-pull-test

pull-test-automation-image-1:
  stage: run-pull-test
  image: registry.gitlab.builder.ai/shared-services/docker-images/automation-image:0.0.72
  script:
    - echo "Hello from image - Automation Image"

pull-test-automation-image-2:
  stage: run-pull-test
  image: registry.gitlab.builder.ai/shared-services/docker-images/automation-image:0.0.72
  script:
    - echo "Hello from image - Automation Image"

pull-test-automation-image-3:
  stage: run-pull-test
  image: registry.gitlab.builder.ai/shared-services/docker-images/automation-image:0.0.72
  script:
    - echo "Hello from image - Automation Image"

EOF

# create the pull jobs for each image dir
for dir in images/*/; do
    echo -e "\n${bold}Processing directory:${normal} $dir\n"
    CONTAINER_IMAGE=$(basename "$dir")

    cat <<EOF >>$OUTFILE

pull-test-${CONTAINER_IMAGE}-1:
  stage: run-pull-test
  image: ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CONTAINER_IMAGE}:${TAG}
  script:
    - echo "Hello from image - $CONTAINER_IMAGE"

pull-test-${CONTAINER_IMAGE}-2:
  stage: run-pull-test
  image: ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CONTAINER_IMAGE}:${TAG}
  script:
    - echo "Hello from image - $CONTAINER_IMAGE"

pull-test-${CONTAINER_IMAGE}-3:
  stage: run-pull-test
  image: ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CONTAINER_IMAGE}:${TAG}
  script:
    - echo "Hello from image - $CONTAINER_IMAGE"

EOF

done