#!/bin/bash

#get highest tag number
# VERSION=`git describe --abbrev=0 --tags 2>/dev/null`
VERSION=$(git tag | grep -E "^[0-9]*\.[0-9]*\.[0-9]*$" | sort -V | tail -1)

if [ -z "$VERSION" ];then
    NEW_TAG="0.0.1"
    echo "No version tag present."
    echo "Creating tag: $NEW_TAG"
    git tag $NEW_TAG
    git push --tags
    echo "No previous version tags, creating new"
    echo "TAG $NEW_TAG"
    exit 0;
fi

#replace . with space so can split into an array
VERSION_BITS=(${VERSION//./ })

#get number parts and increase last one by 1
VNUM1=${VERSION_BITS[0]}
VNUM2=${VERSION_BITS[1]}
VNUM3=${VERSION_BITS[2]}
if "$1" = "true"; then
  VNUM1=$((VNUM1+1))
  VNUM2=0
  VNUM3=0
else
  VNUM3=$((VNUM3+1))
  if [[ $VNUM3 -gt 99 ]]; then
    VNUM3=0
    VNUM2=$((VNUM2+1))
  fi
  if [ $VNUM2 -gt 99 ]; then
    VNUM2=0
    VNUM1=$((VNUM1+1))
  fi
fi



NEW_TAG="${VNUM1}.${VNUM2}.${VNUM3}"
#get current hash and see if it already has a tag
GIT_COMMIT=$(git rev-parse HEAD)
CURRENT_COMMIT_TAG=$(git describe --contains $GIT_COMMIT 2>/dev/null)

#only tag if no tag already (would be better if the git describe command above could have a silent option)
if [ -z "$CURRENT_COMMIT_TAG" ]; then
    echo "Updating $VERSION to $NEW_TAG"
    git tag $NEW_TAG
    if git push --tags; then
      echo "New Tag created and pushed"
      echo "TAG $NEW_TAG"
    fi
else
    echo "This commit is already tagged"
      echo "TAG $CURRENT_COMMIT_TAG"
fi




